<?php
/**************************************************************************\
* eGroupWare                                                               *
* http://www.egroupware.org                                                *
* --------------------------------------------                             *
*  This program is free software; you can redistribute it and/or modify it *
*  under the terms of the GNU General Public License as published by the   *
*  Free Software Foundation; either version 2 of the License, or (at your  *
*  option) any later version.                                              *
\**************************************************************************/

/**
 * This is an other big workaround. In ajax calls, we use controller.php
 * directly, which do not includes header.inc for performance issues.
 * However, for phpgwAPI to work properly we need to set several
 * constants and objects, which are created in this file (header.inc).
 * As much as this problem still unsolved (by phpAPI group), this potencially
 * problematic and ugly code must still here.. =(
 */
$old = $GLOBALS['phpgw_info']['flags'];
$GLOBALS['phpgw_info']['flags'] = array(
        'noheader' => True,
        'nonavbar' => True,
        'currentapp' => 'workflow'
);

/**
 * the base dir must be relative to this file location because
 * the root directory is not the some in every call.
 */
$base = dirname(dirname(dirname(__FILE__)));

/* including expresso's header.inc.php */
require_once ($base . '/header.inc.php');

/* restoring old flags */
$GLOBALS['phpgw_info']['flags'] = $old;


/* assure that the correct encoding will be used (e.g string functions) */
setlocale(LC_CTYPE, 'pt_BR', 'pt_BR.iso-8859-1', 'pt_BR.utf-8');


/* define o umask para a criao de arquivos por parte do Workflow */
umask(007);


/**
 * Server base path. In this module, we should only use
 * constants defined here. PHPGW_SERVER_ROOT is defined
 * on 'header.inc.php' which is always included by this
 * file.
 * @name EGW_SERVER_ROOT
 */
define('EGW_SERVER_ROOT', PHPGW_SERVER_ROOT);

/**
 * Server include base path. We must define our own constants
 * because there are several cases in which workflow is called
 * directly, thus PHPGW constants are not defined.
 * @name EGW_INC_ROOT
 */
define('EGW_INC_ROOT', EGW_SERVER_ROOT . '/phpgwapi/inc/');

/**
 * Workflow base path.
 * @name WF_SERVER_ROOT
 */
define('WF_SERVER_ROOT', EGW_SERVER_ROOT.'/workflow/');

/**
 * Workflow include path.
 * @name WF_INC_ROOT
 */
define('WF_INC_ROOT', WF_SERVER_ROOT.'/inc/');

/**
 * Workflow lib base dir.
 * @name WF_LIB_ROOT
 */
define('WF_LIB_ROOT', WF_SERVER_ROOT.'/lib/');


/* including common classes */
require_once WF_LIB_ROOT . 'security/Security.php';
require_once WF_LIB_ROOT . 'factory/Factory.php';
require_once WF_LIB_ROOT . 'factory/BaseFactory.php';
require_once WF_LIB_ROOT . 'factory/WorkflowFactory.php';
require_once WF_LIB_ROOT . 'factory/ProcessFactory.php';
require_once WF_LIB_ROOT . 'settings/Settings.php';

/**
 * Expresso base url.
 * @name EGW_BASE_URL
 */
define('EGW_BASE_URL', Settings::get('expresso', 'webserver_url'));

/**
 * Workflow base url.
 * @name WF_BASE_URL
 */
define('WF_BASE_URL', EGW_BASE_URL . "/workflow/");


$GLOBALS['workflow']['workflowObjects'] = Factory::getInstance('WorkflowObjects');
?>
